## START: Set by rpmautospec
## (rpmautospec version 0.2.5)
%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
## END: Set by rpmautospec

Name:           bear
Version:        3.0.19
Release:        %autorelease
Summary:        Tool that generates a compilation database for clang tooling

License:        GPLv3+
URL:            https://github.com/rizsotto/%{name}
Source:         %{url}/archive/%{version}/%{name}-%{version}.tar.gz

BuildRequires:  cmake
BuildRequires:  cmake(fmt)
BuildRequires:  cmake(gtest)
BuildRequires:  cmake(nlohmann_json)
BuildRequires:  cmake(spdlog)
BuildRequires:  gcc
BuildRequires:  gcc-c++
BuildRequires:  gmock-devel
BuildRequires:  grpc-plugins
BuildRequires:  make
BuildRequires:  pkgconfig(protobuf)
BuildRequires:  pkgconfig(grpc++)
BuildRequires:  python3

# Needed for functional tests
BuildRequires:  python3dist(lit)
BuildRequires:  /usr/bin/more
BuildRequires:  /usr/bin/xargs
BuildRequires:  gcc-fortran
BuildRequires:  valgrind
BuildRequires:  fakeroot

# Work around RHBZ#1959600 (https://github.com/rizsotto/Bear/issues/309), which
# caused a test failure on s390x. It may only be happenstance that no other
# architectures were affected.
%global _lto_cflags %{nil}

%description
Build ear produces compilation database in JSON format. This database describes
how single compilation unit should be processed and can be used by Clang
tooling.

%prep
%autosetup -p 1 -n Bear-%{version}


%build
for f in $(ls test/bin/); do
    sed -i "s|^#\!/usr/bin/env\s\+python\s\?$|#!%{__python3}|" test/bin/$f
done

# Functional tests are broken for some unknown reason, disable for now.
%cmake -DENABLE_FUNC_TESTS=ON -DENABLE_UNIT_TESTS=ON
%cmake_build

%install
%cmake_install

mv %{buildroot}/%{_docdir}/Bear %{buildroot}/%{_docdir}/bear

%check
# Tests run as part of build, because it's the same build target.
# There is no check target.


%files
%{_bindir}/bear
%{_bindir}/citnames
%{_bindir}/intercept
%{_libdir}/bear
%{_mandir}/man1/bear.1*
%{_mandir}/man1/citnames.1*
%{_mandir}/man1/intercept.1*

# rpmbuild on RHEL won't automatically pick up ChangeLog.md & README.md
%if 0%{?rhel}
%{_datadir}/doc/bear
%endif

%license COPYING
%doc %{_docdir}/bear

%changelog
* Wed Mar 23 2022 Dan Čermák <dan.cermak@cgc-instruments.com> 3.0.19-1
- New upstream release 3.0.19, fixes rhbz#2066148

* Wed Mar 09 2022 Dan Čermák <dan.cermak@cgc-instruments.com> 3.0.18-3
- Rebuild for abseil-cpp 20211102.0

* Wed Jan 19 2022 Fedora Release Engineering <releng@fedoraproject.org> 3.0.18-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Mon Jan 10 2022 Dan Čermák <dan.cermak@cgc-instruments.com> 3.0.18-1
- New upstream release 3.0.18, fixes rhbz#2036416

* Mon Nov 22 2021 Dan Čermák <dan.cermak@cgc-instruments.com> 3.0.17-1
- New upstream release 3.0.17, fixes rhbz#2023138

* Sat Nov 06 2021 Adrian Reber <adrian@lisas.de> 3.0.16-2
- Rebuilt for protobuf 3.19.0

* Sat Nov 06 2021 Dan Čermák <dan.cermak@cgc-instruments.com> 3.0.16-1
- New upstream release 3.0.16, fixes rhbz#2007711

* Sat Nov 06 2021 Dan Čermák <dan.cermak@cgc-instruments.com> 3.0.15-6
- Enable unit tests & add optional test dependencies

* Fri Nov 05 2021 Adrian Reber <adrian@lisas.de> 3.0.15-5
- Rebuilt for protobuf 3.19.0

* Sun Oct 24 2021 Adrian Reber <adrian@lisas.de> 3.0.15-4
- Rebuilt for protobuf 3.18.1

* Thu Oct 07 2021 Dan Čermák <dan.cermak@cgc-instruments.com> 3.0.15-3
- Rebuild for grpc 1.41

* Mon Sep 20 2021 Dan Čermák <dan.cermak@cgc-instruments.com> 3.0.15-2
- Re-enable functional tests

* Mon Sep 20 2021 Dan Čermák <dan.cermak@cgc-instruments.com> 3.0.15-1
- New upstream release 3.0.15, fixes rhbz#2002549

* Thu Sep 02 2021 Dan Čermák <dan.cermak@cgc-instruments.com> 3.0.14-1
- New upstream release 3.0.14, Fixes rhbz#1999918

* Sun Aug 01 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.13-4
- Rebuild for grpc 1.39

* Wed Jul 21 2021 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.13-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Mon Jul 05 2021 Richard Shaw <hobbes1069@gmail.com> - 3.0.13-2
- Rebuild for new fmt version.

* Mon Jun 28 2021 Dan Čermák <dan.cermak@cgc-instruments.com> - 3.0.13-1
- New upstream release 3.0.13
- Fixes rhbz#1976681

* Tue Jun 01 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.12-1
- Update to 3.0.12
- Fixes rhbz#1966378
- Drop bear.libexec-subdir.patch, merged upstream in PR#348 and included in the
  current release

* Mon May 17 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.11-1
- Update to 3.0.11 (RHBZ#1921884)
- Drop bear.missing-includes.patch, which was upstreamed
- Rebase bear.libexec-subdir.patch from PR#348 as actually merged upstream
- Disable LTO to work around RHBZ#1959600
- Change pkgconfig(grpc) to pkgconfig(grpc++), and add pkgconfig(protobuf), to
  match the actual modules searched for in source/CMakeLists.txt

* Tue Jan 26 2021 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.7-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Sun Jan 24 2021 Till Hofmann <thofmann@fedoraproject.org> - 3.0.7-1
- Update to 3.0.7

* Wed Dec 30 11:58:35 CET 2020 Till Hofmann <thofmann@fedoraproject.org> - 3.0.6-1
- Update to 3.0.6

* Sun Sep 13 2020 Dan Čermák <dan.cermak@cgc-instruments.com> - 2.4.4-1
- New upstream release 2.4.4 (rhbz#1877901)

* Mon Jul 27 2020 Fedora Release Engineering <releng@fedoraproject.org> - 2.4.3-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Tue Jan 28 2020 Fedora Release Engineering <releng@fedoraproject.org> - 2.4.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Sun Jan 26 2020 Dan Čermák <dan.cermak@cgc-instruments.com> - 2.4.3-1
- Bump version to 2.4.3

* Sun Sep  8 2019 Dan Čermák <dan.cermak@cgc-instruments.com> - 2.4.2-1
- Bump version to 2.4.2

* Wed Jul 31 2019 Wolfgang Stöggl <c72578@yahoo.de> - 2.4.1-1
- Bump version to 2.4.1
- Add %%{_datadir}/bash-completion/completions/bear to %%files

* Wed Jul 24 2019 Fedora Release Engineering <releng@fedoraproject.org> - 2.4.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Tue May 14 2019 Dan Čermák <dan.cermak@cgc-instruments.de> - 2.4.0-1
- Bump version to 2.4.0

* Thu Jan 31 2019 Fedora Release Engineering <releng@fedoraproject.org> - 2.3.13-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Fri Jan 25 2019 Jonathan Wakely <jwakely@redhat.com> - 2.3.13-3
- Rebuilt for Boost 1.69

* Sat Nov 24 2018 Dan Čermák <dan.cermak@cgc-instruments.de> - 2.3.13-2
- Implement suggestions from Robert-André Mauchin and Till Hofmann

* Fri Oct  5 2018 Dan Čermák <dan.cermak@cgc-instruments.de> - 2.3.13-1
- Bump version to 2.3.13

* Tue Apr 10 2018 Dan Čermák <dan.cermak@cgc-instruments.de> 2.3.11-1
- Bump version to 2.3.11

* Thu Sep 03 2015 Pavel Odvody <podvody@redhat.com> 2.1.2-1.git15f4447
- new package built with tito

